#ifdef	_DEBUG

#include	<stdio.h>
#include	"ppc403ga.h"
#include	"../../window/console/console.h"

extern	CONSOLE	con;



void			PPC403GA::reg_stat(void)
{
	char			buf[0x100];
	unsigned long	x;

	sprintf(buf,"GPR %08X,%08X,%08X,%08X,%08X,%08X,%08X,%08X\n",
		r[GPR0],	r[GPR1],	r[GPR2],	r[GPR3],
		r[GPR4],	r[GPR5],	r[GPR6],	r[GPR7]);	CO(buf);
	sprintf(buf,"    %08X,%08X,%08X,%08X,%08X,%08X,%08X,%08X\n",
		r[GPR8],	r[GPR9],	r[GPR10],	r[GPR11],
		r[GPR12],	r[GPR13],	r[GPR14],	r[GPR15]);	CO(buf);
	sprintf(buf,"    %08X,%08X,%08X,%08X,%08X,%08X,%08X,%08X\n",
		r[GPR16],	r[GPR17],	r[GPR18],	r[GPR19],
		r[GPR20],	r[GPR21],	r[GPR22],	r[GPR23]);	CO(buf);
	sprintf(buf,"    %08X,%08X,%08X,%08X,%08X,%08X,%08X,%08X\n",
		r[GPR24],	r[GPR25],	r[GPR26],	r[GPR27],
		r[GPR28],	r[GPR29],	r[GPR30],	r[GPR31]);	CO(buf);

	sprintf(buf,"CTR %08X,     XER %08X,      LR %08X,      PC %08X\n",
		r[SPR_CTR],	r[SPR_XER],	r[SPR_LR],	r[PC]);		CO(buf);

	CO("CR  0-LGES  1-LGES  2-LGES  3-LGES  ");
	CO("4-LGES  5-LGES  6-LGES  7-LGES\n  ");
	for(x=0;x!=8;x++){
											buf[x*8+0]=' ';
											buf[x*8+1]=' ';
											buf[x*8+2]=' ';
											buf[x*8+3]=' ';
		if(r[SPR_CR]&(0x80000000>>(x*4+0)))	buf[x*8+4]='1';
			else							buf[x*8+4]='0';
		if(r[SPR_CR]&(0x80000000>>(x*4+1)))	buf[x*8+5]='1';
			else							buf[x*8+5]='0';
		if(r[SPR_CR]&(0x80000000>>(x*4+2)))	buf[x*8+6]='1';
			else							buf[x*8+6]='0';
		if(r[SPR_CR]&(0x80000000>>(x*4+3)))	buf[x*8+7]='1';
			else							buf[x*8+7]='0';	}
											buf[8*8+0]=NULL;
	CO(buf);
	sprintf(buf," %08X\n",r[SPR_CR]);	CO(buf);
}



void			PPC403GA::reg_stat_spr(void)
{
	char			buf[0x100];

	CO("DAC1\t");	sprintf(buf,"%08X,",r[SPR_DAC1]);	CO(buf);
	CO("DAC2\t");	sprintf(buf,"%08X,",r[SPR_DAC2]);	CO(buf);
	CO("DBCR\t");	sprintf(buf,"%08X,",r[SPR_DBCR]);	CO(buf);
	CO("DBSR\t");	sprintf(buf,"%08X\n",r[SPR_DBSR]);	CO(buf);

	CO("DCCR\t");	sprintf(buf,"%08X,",r[SPR_DCCR]);	CO(buf);
	CO("DEAR\t");	sprintf(buf,"%08X,",r[SPR_DEAR]);	CO(buf);
	CO("ESR\t");	sprintf(buf,"%08X,",r[SPR_ESR]);	CO(buf);
	CO("EVPR\t");	sprintf(buf,"%08X\n",r[SPR_EVPR]);	CO(buf);

	CO("PBU1\t");	sprintf(buf,"%08X,",r[SPR_PBU1]);	CO(buf);
	CO("PBL1\t");	sprintf(buf,"%08X,",r[SPR_PBL1]);	CO(buf);
	CO("PBU2\t");	sprintf(buf,"%08X,",r[SPR_PBU2]);	CO(buf);
	CO("PBL2\t");	sprintf(buf,"%08X\n",r[SPR_PBL2]);	CO(buf);

	CO("IAC1\t");	sprintf(buf,"%08X,",r[SPR_IAC1]);	CO(buf);
	CO("IAC2\t");	sprintf(buf,"%08X,",r[SPR_IAC2]);	CO(buf);
	CO("ICCR\t");	sprintf(buf,"%08X\n",r[SPR_ICCR]);	CO(buf);

	CO("ICDBDR\t");	sprintf(buf,"%08X,",r[SPR_ICDBDR]);	CO(buf);
	CO("CDBCR\t");	sprintf(buf,"%08X,",r[SPR_CDBCR]);	CO(buf);
	CO("PIT\t");	sprintf(buf,"%08X,",r[SPR_PIT]);	CO(buf);
	CO("MSR\t");	sprintf(buf,"%08X\n",r[SPR_MSR]);	CO(buf);

	CO("TBHI\t");	sprintf(buf,"%08X,",r[SPR_TBHI]);	CO(buf);
	CO("TBLO\t");	sprintf(buf,"%08X,",r[SPR_TBLO]);	CO(buf);
	CO("TCR\t");	sprintf(buf,"%08X,",r[SPR_TCR]);	CO(buf);
	CO("TSR\t");	sprintf(buf,"%08X\n",r[SPR_TSR]);	CO(buf);

	sprintf(buf,"SPRG	%08X,%08X,%08X,%08X\n",
	r[SPR_SPRG0],	r[SPR_SPRG1],	r[SPR_SPRG2],	r[SPR_SPRG3]);	CO(buf);
	sprintf(buf,"SRR	%08X,%08X,%08X,%08X\n",
	r[SPR_SRR0],	r[SPR_SRR1],	r[SPR_SRR2],	r[SPR_SRR3]);	CO(buf);
}



void			PPC403GA::reg_stat_dcr(void)
{
	char			buf[0x100];

	sprintf(buf,"BR	%08X,%08X,%08X,%08X,%08X,%08X,%08X,%08X\n",
				r[DCR_BR0],	r[DCR_BR1],	r[DCR_BR2],	r[DCR_BR3],
				r[DCR_BR4],	r[DCR_BR5],	r[DCR_BR6],	r[DCR_BR7]);	CO(buf);

	sprintf(buf,"BEAR	%08X,",r[DCR_BEAR]);		CO(buf);
	sprintf(buf,"    BESR %08X,",r[DCR_BESR]);		CO(buf);
	sprintf(buf,"   EXISR %08X,",r[DCR_EXISR]);		CO(buf);
	sprintf(buf,"   EXIER %08X\n",r[DCR_EXIER]);	CO(buf);

	CO("DMA	CR       CT       DA       SA       CC\n");
	sprintf(buf,"0	%08X,%08X,%08X,%08X,%08X\n",r[DCR_DMACR0],
	r[DCR_DMACT0],	r[DCR_DMADA0],	r[DCR_DMASA0],	r[DCR_DMACC0]);	CO(buf);
	sprintf(buf,"1	%08X,%08X,%08X,%08X,%08X\n",r[DCR_DMACR1],
	r[DCR_DMACT1],	r[DCR_DMADA1],	r[DCR_DMASA1],	r[DCR_DMACC1]);	CO(buf);
	sprintf(buf,"2	%08X,%08X,%08X,%08X,%08X\n",r[DCR_DMACR2],
	r[DCR_DMACT2],	r[DCR_DMADA2],	r[DCR_DMASA2],	r[DCR_DMACC2]);	CO(buf);
	sprintf(buf,"3	%08X,%08X,%08X,%08X,%08X\n",r[DCR_DMACR3],
	r[DCR_DMACT3],	r[DCR_DMADA3],	r[DCR_DMASA3],	r[DCR_DMACC3]);	CO(buf);

	sprintf(buf,"DMASR	%08X,",r[DCR_EXISR]);		CO(buf);
	sprintf(buf,"    IOCR %08X\n",r[DCR_EXIER]);	CO(buf);
}



void			PPC403GA::mem_dump(unsigned long addr)
{
	unsigned long	x,y;
	char			buf[0x100];
	char			asc[0x100];

	sprintf(buf,"%08X +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F "
		"0123456789ABCDEF\n",addr);	CO(buf);

	for(y=0;y!=16;y++){
		sprintf(buf,"%08X ",y*16+addr);	CO(buf);

		for(x=0;x!=16;x++){
			asc[x]=r1(addr+y*16+x);
			sprintf(buf+x*3,"%02X ",(unsigned char)asc[x]);	}
		CO(buf);
		asc[16]=NULL;	asc[17]=NULL;
		for(x=0;x<=16;){
			if((0x81<=asc[x])&&(0xfc>=asc[x])&&(0x9f>=asc[x])||(0xe0<=asc[x]))
				if((0x40<=asc[x+1])&&(0xfc>=asc[x+1]))	x+=2;
				else{	asc[x]='.';	x++;	}
			else{	if(!isgraph(0x000000ff&(int)asc[x]))	asc[x]='.';
					x++;													}
		}
		asc[16]=NULL;	asc[17]=NULL;	CO(asc);	CO("\n");
	}
}



void	PPC403GA::dump2file(unsigned long start,unsigned long end,char *fname)
{
	HANDLE			hDUMP;
	unsigned long	tl1,tl2;
	unsigned char	tc;

	hDUMP=CreateFile(fname,GENERIC_WRITE,0,0,CREATE_ALWAYS,
										FILE_ATTRIBUTE_NORMAL,0);
	if(hDUMP==(void *)-1){	CO("may be invalid filename\n");	return;	}
	if(start>end){	tl1=start;	start=end;	end=tl1;	}
	for(tl1=start;tl1<end;tl1++){
		tc=r1(tl1);
		WriteFile(hDUMP,&tc,1,&tl2,NULL);	}
	CloseHandle(hDUMP);
}



void			PPC403GA::er1(unsigned char reg,unsigned char  data){}
void			PPC403GA::er2(unsigned char reg,unsigned short data){}
void			PPC403GA::er4(unsigned char reg,unsigned long  data)
{	r[reg]=data;	}

void			PPC403GA::em1(unsigned long addr,unsigned char  data)
{	w1(addr,data);	}
void			PPC403GA::em2(unsigned long addr,unsigned short data)
{	w2(addr,data);	}
void			PPC403GA::em4(unsigned long addr,unsigned long  data)
{	w4(addr,data);	}



#endif	_DEBUG
