#include	<stdio.h>
#include	"ppc403ga.h"

#ifdef	_DEBUG
#include	<stdio.h>
#include	"../../window/console/console.h"

extern		CONSOLE		con;
#endif



#ifdef	_DEBUG
#include	"../../window/console/console.h"
extern	CONSOLE	con;
#endif


void	PPC403GA::interrupt(void)
{
	unsigned long	i;

	for(i=0;i<PPCINT_MAX;i++)
		if(isl[i]&0x80)
			switch(i){
				case	PPCINT_CORE_RESET:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tCORE_RESET\n");
#endif
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_ME |
									MSR_DE |
									MSR_PE |
									MSR_PX 	);
					r[PC]=0xfffffffc;
					isl[i]&=0x7f;	return;



				case	PPCINT_CHIP_RESET:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tCHIP_RESET\n");
#endif
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_ME |
									MSR_DE |
									MSR_PE |
									MSR_PX 	);
					r[PC]=0xfffffffc;
					isl[i]&=0x7f;	return;



				case	PPCINT_SYSTEM_RESET:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tSYSTEM_RESET\n");
#endif
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_ME |
									MSR_DE |
									MSR_PE |
									MSR_PX 	);
					r[PC]=0xfffffffc;
					isl[i]&=0x7f;	return;



				case	PPCINT_CRITICAL_INTERRUPT_PIN_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tCRITICAL_INTERRUPT_PIN_EXCEPTION\n");
#endif
					r[SPR_SRR2]=r[PC];
					r[SPR_SRR3]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_DE |
									MSR_PE 	);
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0100;
					isl[i]&=0x7f;	return;



				case	PPCINT_MACHINE_CHECK_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tMACHINE_CHECK_EXCEPTION\n");
#endif
					r[SPR_SRR2]=r[PC];
					r[SPR_SRR3]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_ME |
									MSR_DE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0200;
//					r[SPR_BEAR]=???;
//					r[SPR_BESR]=???;
//					r[SPR_ESR]=???;
					isl[i]&=0x7f;	return;



				case	PPCINT_PROTECTION_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tPROTECTION_EXCEPTION\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0300;
					isl[i]&=0x7f;	return;



				case	PPCINT_EXTERNAL_INTERRUPT_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tEXTERNAL_INTERRUPT_EXCEPTION\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0500;
					isl[i]&=0x7f;	return;



				case	PPCINT_ALIGNMENT_ERROR:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tALIGNMENT_ERROR\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0600;
					isl[i]&=0x7f;	return;



				case	PPCINT_PROGRAM_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tPROGRAM_EXCEPTION\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0700;
					isl[i]&=0x7f;	return;



				case	PPCINT_SYSTEM_CALL:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tSYSTEM_CALL\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x0c00;
					isl[i]&=0x7f;	return;



				case	PPCINT_PROGRAMMABLE_INTERVAL_TIMER:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tPROGRAMMABLE_INTERVAL_TIMER\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x1000;
					isl[i]&=0x7f;	return;



				case	PPCINT_FIXED_INTERVAL_TIMER:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tFIXED_INTERVAL_TIMER\n");
#endif
					r[SPR_SRR0]=r[PC];
					r[SPR_SRR1]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_EE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x1010;
					isl[i]&=0x7f;	return;



				case	PPCINT_WATCHDOG_TIMER:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tWATCHDOG_TIMER\n");
#endif
					r[SPR_SRR2]=r[PC];
					r[SPR_SRR3]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_DE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x1020;
					r[SPR_TSR]|=0x40000000;
					isl[i]&=0x7f;	return;



				case	PPCINT_DEBUG_EXCEPTION:
#ifdef	_DEBUG
//if(r[VSR]&VSR_DISP_CODE)
	CO("<INT>\tDEBUG_EXCEPTION\n");
#endif
					r[SPR_SRR2]=r[PC];
					r[SPR_SRR3]=r[SPR_MSR];
					r[SPR_MSR]&=~(	MSR_WE |
									MSR_PR |
									MSR_CE |
									MSR_EE |
									MSR_DE |
									MSR_PE );
					r[PC]=(r[SPR_EVPR]&0xffff0000)|0x2000;
//					r[SPR_DBSR]=???;
					isl[i]&=0x7f;	return;



				default:
#ifdef	_DEBUG
	CO("<ERROR>\tINVALID INT NUMBER !!!\n");
#endif
					isl[i]&=0x7f;	return;
			}
}
