#include	"ppc403ga.h"

#ifdef	_DEBUG
#include	<stdio.h>
#include	"../../window/console/console.h"

extern		CONSOLE		con;
#endif

unsigned long	PPC403GA::spr_r(unsigned long SPRN)
{
#ifdef	_DEBUG
	char			buf[0x1000];

switch(SPRN){
case 0x3d7: sprintf(buf,"SPR CDBCR > %08X\n",r[SPR_CDBCR]);	CO(buf);break;
case 0x009: sprintf(buf,"SPR CTR > %08X\n",r[SPR_CTR]);		CO(buf);break;
case 0x3f6: sprintf(buf,"SPR DAC1 > %08X\n",r[SPR_DAC1]);	CO(buf);break;
case 0x3f7: sprintf(buf,"SPR DAC2 > %08X\n",r[SPR_DAC2]);	CO(buf);break;
case 0x3f2: sprintf(buf,"SPR DBCR > %08X\n",r[SPR_DBCR]);	CO(buf);break;
case 0x3f0: sprintf(buf,"SPR DBSR > %08X\n",r[SPR_DBSR]);	CO(buf);break;
case 0x3fa: sprintf(buf,"SPR DCCR > %08X\n",r[SPR_DCCR]);	CO(buf);break;
case 0x3d5: sprintf(buf,"SPR DEAR > %08X\n",r[SPR_DEAR]);	CO(buf);break;
case 0x3d4: sprintf(buf,"SPR ESR > %08X\n",r[SPR_ESR]);		CO(buf);break;
case 0x3d6: sprintf(buf,"SPR EVPR > %08X\n",r[SPR_EVPR]);	CO(buf);break;
case 0x3f4: sprintf(buf,"SPR IAC1 > %08X\n",r[SPR_IAC1]);	CO(buf);break;
case 0x3f5: sprintf(buf,"SPR IAC2 > %08X\n",r[SPR_IAC2]);	CO(buf);break;
case 0x3fb: sprintf(buf,"SPR ICCR > %08X\n",r[SPR_ICCR]);	CO(buf);break;
case 0x3d3: sprintf(buf,"SPR ICDBDR > %08X\n",r[SPR_ICDBDR]);CO(buf);break;
//case 0x008: sprintf(buf,"SPR LR > %08X\n",r[SPR_LR]);		CO(buf);break;
case 0x3fc: sprintf(buf,"SPR PBL1 > %08X\n",r[SPR_PBL1]);	CO(buf);break;
case 0x3fe: sprintf(buf,"SPR PBL2 > %08X\n",r[SPR_PBL2]);	CO(buf);break;
case 0x3fd: sprintf(buf,"SPR PBU1 > %08X\n",r[SPR_PBU1]);	CO(buf);break;
case 0x3ff: sprintf(buf,"SPR PBU2 > %08X\n",r[SPR_PBU2]);	CO(buf);break;
case 0x3db: sprintf(buf,"SPR PIT > %08X\n",r[SPR_PIT]);		CO(buf);break;
case 0x11f: sprintf(buf,"SPR PVR > 00200011\n");			CO(buf);break;
case 0x110: sprintf(buf,"SPR SPRG0 > %08X\n",r[SPR_SPRG0]);	CO(buf);break;
case 0x111: sprintf(buf,"SPR SPRG1 > %08X\n",r[SPR_SPRG1]);	CO(buf);break;
case 0x112: sprintf(buf,"SPR SPRG2 > %08X\n",r[SPR_SPRG2]);	CO(buf);break;
case 0x113: sprintf(buf,"SPR SPRG3 > %08X\n",r[SPR_SPRG3]);	CO(buf);break;
case 0x01a: sprintf(buf,"SPR SRR0 > %08X\n",r[SPR_SRR0]);	CO(buf);break;
case 0x01b: sprintf(buf,"SPR SRR1 > %08X\n",r[SPR_SRR1]);	CO(buf);break;
case 0x3de: sprintf(buf,"SPR SRR2 > %08X\n",r[SPR_SRR2]);	CO(buf);break;
case 0x3df: sprintf(buf,"SPR SRR3 > %08X\n",r[SPR_SRR3]);	CO(buf);break;
case 0x3dc: sprintf(buf,"SPR TBHI > %08X\n",r[SPR_TBHI]);	CO(buf);break;
//case 0x3dd: sprintf(buf,"SPR TBLO > %08X\n",r[SPR_TBLO]);	CO(buf);break;
case 0x3da: sprintf(buf,"SPR TCR > %08X\n",r[SPR_TCR]);		CO(buf);break;
case 0x3d8: sprintf(buf,"SPR TSR > %08X\n",r[SPR_TSR]);		CO(buf);break;
case 0x001: sprintf(buf,"SPR XER > %08X\n",r[SPR_XER]);		CO(buf);break;
}
#endif

	switch(SPRN){
		case	0x3d7:	return(r[SPR_CDBCR]);
		case	0x009:	return(r[SPR_CTR]);
		case	0x3f6:	return(r[SPR_DAC1]);
		case	0x3f7:	return(r[SPR_DAC2]);
		case	0x3f2:	return(r[SPR_DBCR]);
		case	0x3f0:	return(r[SPR_DBSR]);
		case	0x3fa:	return(r[SPR_DCCR]);
		case	0x3d5:	return(r[SPR_DEAR]);
		case	0x3d4:	return(r[SPR_ESR]);
		case	0x3d6:	return(r[SPR_EVPR]);
		case	0x3f4:	return(r[SPR_IAC1]);
		case	0x3f5:	return(r[SPR_IAC2]);
		case	0x3fb:	return(r[SPR_ICCR]);
		case	0x3d3:	return(r[SPR_ICDBDR]);
		case	0x008:	return(r[SPR_LR]);
		case	0x3fc:	return(r[SPR_PBL1]);
		case	0x3fe:	return(r[SPR_PBL2]);
		case	0x3fd:	return(r[SPR_PBU1]);
		case	0x3ff:	return(r[SPR_PBU2]);
		case	0x3db:	return(r[SPR_PIT]);
		case	0x11f:	return(0x00200011);		//PVR
		case	0x110:	return(r[SPR_SPRG0]);
		case	0x111:	return(r[SPR_SPRG1]);
		case	0x112:	return(r[SPR_SPRG2]);
		case	0x113:	return(r[SPR_SPRG3]);
		case	0x01a:	return(r[SPR_SRR0]);
		case	0x01b:	return(r[SPR_SRR1]);
		case	0x3de:	return(r[SPR_SRR2]);
		case	0x3df:	return(r[SPR_SRR3]);
		case	0x3dc:	return(r[SPR_TBHI]);
		case	0x3dd:	return(r[SPR_TBLO]);
		case	0x3da:	return(r[SPR_TCR]);
		case	0x3d8:	return(r[SPR_TSR]);
		case	0x001:	return(r[SPR_XER]);
	}

#ifdef	_DEBUG
	sprintf(buf,"invalid SPR number addr=%08X code=%08X\n",r[PC],r4(r[PC]));
	CO(buf);
#endif
	return(0xffffffff);
}



void	PPC403GA::spr_w(unsigned long SPRN,unsigned long data)
{
#ifdef	_DEBUG
	char			buf[0x1000];

	switch(SPRN){
		case	0x3d7:	CO("SPR CDBCR");	break;
//		case	0x009:	CO("SPR CTR");		break;
		case	0x009:	goto escape;
		case	0x3f6:	CO("SPR DAC1");		break;
		case	0x3f7:	CO("SPR DAC2");		break;
		case	0x3f2:	CO("SPR DBCR");		break;
		case	0x3f0:	CO("SPR DBSR");		break;
		case	0x3fa:	CO("SPR DCCR");		break;
		case	0x3d4:	CO("SPR ESR");		break;
		case	0x3d6:	CO("SPR EVPR");		break;
		case	0x3f4:	CO("SPR IAC1");		break;
		case	0x3f5:	CO("SPR IAC2");		break;
		case	0x3fb:	CO("SPR ICCR");		break;
//		case	0x008:	CO("SPR LR");		break;
		case	0x008:	goto escape;
		case	0x3fc:	CO("SPR PBL1");		break;
		case	0x3fe:	CO("SPR PBL2");		break;
		case	0x3fd:	CO("SPR PBU1");		break;
		case	0x3ff:	CO("SPR PBU2");		break;
		case	0x3db:	CO("SPR PIT");		break;
		case	0x110:	CO("SPR SPRG0");	break;
		case	0x111:	CO("SPR SPRG1");	break;
		case	0x112:	CO("SPR SPRG2");	break;
		case	0x113:	CO("SPR SPRG3");	break;
		case	0x01a:	CO("SPR SRR0");		break;
		case	0x01b:	CO("SPR SRR1");		break;
		case	0x3de:	CO("SPR SRR2");		break;
		case	0x3df:	CO("SPR SRR3");		break;
		case	0x3dc:	CO("SPR TBHI");		break;
//		case	0x3dd:	CO("SPR TBLO");		break;
		case	0x3dd:
			sprintf(buf,"SPR TBLO (%08X)",r[SPR_TBLO]);	CO(buf);	break;
		case	0x3da:	CO("SPR TCR");		break;
		case	0x3d8:	CO("SPR TSR");		break;
//		case	0x001:	CO("SPR XER");		break;
		case	0x001:	goto escape;
	}
	sprintf(buf," < %08X\n",data);	CO(buf);
escape:
#endif

	switch(SPRN){
		case	0x3d7:	r[SPR_CDBCR]=data;	return;
		case	0x009:	r[SPR_CTR]=data;	return;
		case	0x3f6:	r[SPR_DAC1]=data;	return;
		case	0x3f7:	r[SPR_DAC2]=data;	return;
		case	0x3f2:	r[SPR_DBCR]=data;	return;
		case	0x3f0:	r[SPR_DBSR]=data;	return;
//		case	0x3fa:	r[SPR_DCCR]&=data;	return;
		case	0x3fa:	r[SPR_DCCR]=data;	return;
		case	0x3d4:	r[SPR_ESR]=data;	return;
		case	0x3d6:	r[SPR_EVPR]=data;	return;
		case	0x3f4:	r[SPR_IAC1]=data;	return;
		case	0x3f5:	r[SPR_IAC2]=data;	return;
		case	0x3fb:	r[SPR_ICCR]=data;	return;
		case	0x008:	r[SPR_LR]=data;		return;
		case	0x3fc:	r[SPR_PBL1]=data;	return;
		case	0x3fe:	r[SPR_PBL2]=data;	return;
		case	0x3fd:	r[SPR_PBU1]=data;	return;
		case	0x3ff:	r[SPR_PBU2]=data;	return;
		case	0x3db:	r[SPR_PIT]=data;	return;
		case	0x110:	r[SPR_SPRG0]=data;	return;
		case	0x111:	r[SPR_SPRG1]=data;	return;
		case	0x112:	r[SPR_SPRG2]=data;	return;
		case	0x113:	r[SPR_SPRG3]=data;	return;
		case	0x01a:	r[SPR_SRR0]=data;	return;
		case	0x01b:	r[SPR_SRR1]=data;	return;
		case	0x3de:	r[SPR_SRR2]=data;	return;
		case	0x3df:	r[SPR_SRR3]=data;	return;
		case	0x3dc:	r[SPR_TBHI]=data;	return;
		case	0x3dd:	r[SPR_TBLO]=data;	return;
		case	0x3da:	r[SPR_TCR]=data;	return;
		case	0x3d8:	r[SPR_TSR]&=data;	return;
		case	0x001:	r[SPR_XER]=data;	return;
	}

#ifdef	_DEBUG
	sprintf(buf,"invalid SPR number addr=%08X code=%08X\n",r[PC],r4(r[PC]));
	CO(buf);
#endif
}



